#%%global snapshot_date 20140530
#%%global snapshot_rev 430863ffea2f6101fbfc0ee35ee098ab2f96b53c
#%%global snapshot_rev_short %(echo %snapshot_rev | cut -c1-6)
#%%global branch trunk

Name:           mingw-w64-tools
Version:        12.0.0
Release:        %mkrel 2
Summary:        Supplementary tools which are part of the mingw-w64 toolchain
# From Debian: Add missing CPU information (ia64, s390, s390x)
Patch0:         widl-missing-cpu-info.patch
# From Debian: Drop unused platform-specific context definitions
Patch1:         widl-no-context.patch
# From Debian: Don't error out on non-Windows CPUs
Patch2:         widl-cpu.patch

# https://sourceforge.net/mailarchive/forum.php?thread_name=5157C0FC.1010309%40users.sourceforge.net&forum_name=mingw-w64-public
# The tools gendef and genidl are GPLv3+, widl is LGPLv2+
License:        GPLv3+ and LGPLv2+

Group:          Development/Other
URL:            https://mingw-w64.sourceforge.net/
%if 0%{?snapshot_date}
# To regenerate a snapshot:
# Use your regular webbrowser to open https://sourceforge.net/p/mingw-w64/mingw-w64/ci/%{snapshot_rev}/tarball
# This triggers the SourceForge instructure to generate a snapshot
# After that you can pull in the archive with:
# spectool -g mingw-w64-tools.spec
Source0:        https://sourceforge.net/code-snapshots/git/m/mi/mingw-w64/mingw-w64.git/mingw-w64-mingw-w64-%{snapshot_rev}.zip
%else
Source0:        https://downloads.sourceforge.net/mingw-w64/mingw-w64-v%{version}.tar.bz2
%endif

BuildRequires:  make
BuildRequires:  gcc
BuildRequires:  mingw32-filesystem >= 133
BuildRequires:  mingw64-filesystem >= 133
BuildRequires:  ucrt64-filesystem >= 133


%description
Supplementary tools which are part of the mingw-w64 toolchain
It contains gendef, genidl and mingw-w64-widl.


%prep
%if 0%{?snapshot_date}
rm -rf mingw-w64-v%{version}
mkdir mingw-w64-v%{version}
cd mingw-w64-v%{version}
unzip %{S:0}
%autosetup -p1 -D -T -n mingw-w64-v%{version}/mingw-w64-mingw-w64-%{snapshot_rev}
%else
%autosetup -p1 -n mingw-w64-v%{version}
%endif


%build
pushd mingw-w64-tools
    pushd gendef
        %configure
        make %{?_smp_mflags}
    popd

    pushd genidl
        %configure
        make %{?_smp_mflags}
    popd

    pushd widl
        # widl needs to be aware of the location of the IDL files belonging
        # to the toolchain. Therefore it needs to be built for both the win32
        # and win64 targets
        %global _configure ../configure
        export CONFIGURE_TOP=$PWD
        mkdir win32
        pushd win32
          %configure --target=%{mingw32_target} --program-prefix=%{mingw32_target}- --with-widl-includedir=%{mingw32_includedir}
          %make_build
        popd
        mkdir win64
        pushd win64
          %configure --target=%{mingw64_target} --program-prefix=%{mingw64_target}- --with-widl-includedir=%{mingw64_includedir}
          %make_build
        popd
        mkdir ucrt64
        pushd ucrt64
          %configure --target=%{ucrt64_target} --program-prefix=%{ucrt64_target}- --with-widl-includedir=%{ucrt64_includedir}
          %make_build
        popd
    popd
popd


%install
pushd mingw-w64-tools
    %make_install -C gendef
    %make_install -C genidl
    %make_install -C widl/win32
    %make_install -C widl/win64
    %make_install -C widl/ucrt64
popd


%files
%license COPYING
%{_bindir}/gendef
%{_bindir}/genidl
%{_bindir}/%{mingw32_target}-widl
%{_bindir}/%{mingw64_target}-widl
%{_bindir}/%{ucrt64_target}-widl




%changelog
* Mon Jun 30 2025 umeabot <umeabot> 12.0.0-2.mga10
+ Revision: 2230148
- Mageia 10 Mass Rebuild

* Thu Nov 21 2024 daviddavid <daviddavid> 12.0.0-1.mga10
+ Revision: 2118139
- new version: 12.0.0

* Tue Sep 26 2023 tv <tv> 11.0.1-1.mga10
+ Revision: 1991146
- Update to 11.0.1

* Thu Apr 28 2022 tv <tv> 10.0.0-3.mga9
+ Revision: 1854850
- Update to 10.0.0

* Fri Mar 18 2022 umeabot <umeabot> 9.0.0-3.mga9
+ Revision: 1797886
- Mageia 9 Mass Rebuild

* Tue Mar 01 2022 tv <tv> 9.0.0-2.mga9
+ Revision: 1787243
- Add ucrt64 target.

* Fri Oct 22 2021 tv <tv> 9.0.0-1.mga9
+ Revision: 1752662
- Update to 9.0.0

* Fri Feb 05 2021 daviddavid <daviddavid> 8.0.0-1.mga8
+ Revision: 1674904
- new version: 8.0.0

* Thu Sep 24 2020 tv <tv> 7.0.0-1.mga8
+ Revision: 1629810
- 7.0.0
+ danf <danf>
- Switch URLs from http: to https:

* Sat Feb 15 2020 umeabot <umeabot> 6.0.0-2.mga8
+ Revision: 1526931
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sat Jul 06 2019 daviddavid <daviddavid> 6.0.0-1.mga8
+ Revision: 1419044
- new version: 6.0.0

* Tue Jan 01 2019 daviddavid <daviddavid> 5.0.4-1.mga7
+ Revision: 1348195
- new version: 5.0.4

* Sun Sep 23 2018 umeabot <umeabot> 5.0.2-2.mga7
+ Revision: 1299553
- Mageia 7 Mass Rebuild

* Tue Sep 19 2017 tv <tv> 5.0.2-1.mga7
+ Revision: 1155743
- new release

* Tue Apr 05 2016 tv <tv> 3.1.999-0.8.trunk.git430863.20140530.mga6
+ Revision: 998681
- fix build: set CONFIGURE_TOP
- new release

* Mon Feb 15 2016 umeabot <umeabot> 2.0.999-0.9.trunk.r6228.20130403.4.mga6
+ Revision: 961490
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 2.0.999-0.9.trunk.r6228.20130403.3.mga5
+ Revision: 740099
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 2.0.999-0.9.trunk.r6228.20130403.2.mga5
+ Revision: 682515
- Mageia 5 Mass Rebuild

* Sat Oct 26 2013 neoclust <neoclust> 2.0.999-0.9.trunk.r6228.20130403.1.mga4
+ Revision: 546996
- imported package mingw-w64-tools


* Sat Sep  7 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.0.999-0.9.trunk.r6228.20130907
- Update to r6228 (20130907 snapshot)
- Updated instructions to regenerate snapshots
  (SourceForge has changed their SVN infrastructure)

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.999-0.8.trunk.20130403
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Apr  3 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.0.999-0.7.trunk.20130403
- Update to 20130403 snapshot
- Use a different source tarball which doesn't contain unrelevant code (like libiberty)
- Removed Provides: bundled(libiberty)
- Make sure the widl tool is built for both win32 and win64 toolchains
- Upstream has changed the license of the gendef and genidl tools to GPLv3+
  The license of the widl tool is LGPLv2+

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.999-0.6.trunk.20120124
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Mon Oct 15 2012 Jon Ciesla <limburgher@gmail.com> - 2.0.999-0.5.trunk.20120124
- Provides: bundled(libiberty)

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.0.999-0.4.trunk.20120124
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed Mar 28 2012 Dan Horák <dan[at]danny.cz> - 2.0.999-0.3.trunk.20120124
- fix build on s390(x)

* Sun Mar 11 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.0.999-0.2.trunk.20120124
- Eliminated several conditionals

* Mon Jan 30 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 2.0.999-0.1.trunk.20120124
- Initial package

